<?php
/**
 * Plugin checkmajs
 * @author	Thomas Ingles, Jp Pourrez
 *
 **/
class checkmajs extends plxPlugin {
	public $url = 'http://telechargements.pluxml.org/latest-version';
	public $href = 'http://www.pluxml.org/';
	public $caption = 'PluXml.org';
	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	null
	 * @author	Thomas Ingles
	 **/
	public function __construct($default_lang) {

		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# droits pour acc�der � la page config.php et admin.php du plugin
		$this->setConfigProfil(PROFIL_ADMIN);
		#$this->setAdminProfil(PROFIL_ADMIN);

		# ajout du hook
		$this->addHook('AdminSettingsInfos', 'AdminSettingsInfos');

	}

	/**
	 * Méthode qui injecte le js ds la page core/admin/parametres_info.php
	 *
	 * @return	stdio
	 * @author	Thomas Ingles, Jp Pourrez
	 **/
	public function AdminSettingsInfos() {
		$from = $this->getParam('from');
		if(empty($from))
			$from = 'https://api.github.com/repos/pluxml/PluXml/releases/latest';#http://kazimentou.fr/divers/PluXml-download

	 	$available = L_PLUXML_UPDATE_AVAILABLE.' <a href="'.$this->href.'">'.$this->caption.'</a>';
	 	$uptodate = L_PLUXML_UPTODATE;
		$wait = PLX_PLUGINS.__CLASS__ .'/spinner.gif';
?>
<img src="<?php echo $wait ?>" style="display:none" alt="précharger">
<script type="text/javascript">
function check_maj(response) {
	'use strict';

	const node = document.querySelector('#latest-version.blue');
	const version = '<?php echo PLX_VERSION ?>';//data.version;
	var release;
	if(typeof response === 'string') {
		release = response;
	} else if(typeof response === 'object' && typeof response.data.tag_name !== 'undefined') {
		/* https://developer.github.com/v3/repos/releases/#get-the-latest-release */
		release = response.data.tag_name;
	} else {
		return;
	}

	function compareVersion(v1, v2) {
		var v1parts = v1.split('.'), v2parts = v2.split('.');
		var maxLen = Math.max(v1parts.length, v2parts.length);
		var result = 0;
		for(var i = 0; i < maxLen; i++) {
			var part1 = parseInt(v1parts[i], 10) || 0;
			var part2 = parseInt(v2parts[i], 10) || 0;
			if(part1 > part2) {
				result = 1;
				break;
			} else if(part1 < part2) {
				return -1;
				break;
			}
		}
		return result;
	}

	node.classList.remove('blue');//error
	if(compareVersion(release, version) > 0) {
		node.innerHTML = '<?php echo $available ?>';//data.available;
		node.classList.add('orange');
	} else {
		node.textContent = '<?php echo $uptodate ?>';//data.uptodate;
		node.classList.add('green');
	}
}

(function() {
	'use strict';

	const node = document.querySelector('#latest-version.red');
	if(node != null) {
		/* https://developer.github.com/v3/#json-p-callbacks */
		const URL = '<?php echo $from ?>';
		const script = document.createElement('SCRIPT');
		script.type = 'text/javascript';
		script.src = URL + '?callback=check_maj';
		document.head.appendChild(script);

		node.classList.remove('red');
		node.classList.add('blue');
		node.innerHTML = '<img src="<?php echo $wait ?>" style="width:20px;vertical-align:bottom;"> <a target="_blank"href="<?php echo $from ?>"><?php echo __CLASS__. ' : '.$from ?> ...</a>';
	}
})();
</script>
<?php
	}#AdminSettingsInfos()
}#CLASS checkmaf